package org.jboss.cache.commands.legacy.write;

import org.jboss.cache.Fqn;
import org.jboss.cache.NodeSPI;
import org.jboss.cache.commands.write.EvictCommand;
import org.jboss.cache.invocation.InvocationContext;

import java.util.Collection;

/**
 * Evict command for legacy locking schemes like OL and PL.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class LegacyEvictCommand extends EvictCommand
{
   public LegacyEvictCommand(Fqn fqn)
   {
      super(fqn);
   }

   public LegacyEvictCommand()
   {
   }

   @Override
   protected NodeSPI lookupForEviction(InvocationContext ctx, Fqn fqn)
   {
      return dataContainer.peek(fqn, false, true);
   }

   @Override
   protected Collection<Fqn> getRecursiveEvictionNodes()
   {
      return dataContainer.getNodesForEviction(fqn, true);
   }

   @Override
   protected boolean evictNode(Fqn fqn, InvocationContext ctx, NodeSPI node)
   {
      notifier.notifyNodeEvicted(fqn, true, ctx);
      try
      {
         if (node == null) return true;
         if (node.hasChildrenDirect() || fqn.isRoot())
         {
            if (trace) log.trace("removing DATA as node has children: evict(" + fqn + ")");
            node.clearDataDirect();
            node.setDataLoaded(false);
            return false;
         }
         else
         {
            if (trace) log.trace("removing NODE as it is a leaf: evict(" + fqn + ")");
            NodeSPI parentNode = lookupForEviction(ctx, fqn.getParent());

            if (parentNode != null)
            {
               parentNode.removeChildDirect(fqn.getLastElement());
               parentNode.setChildrenLoaded(false);
            }
            node.setValid(false, false);
            node.markAsDeleted(true);
            return true;
         }
      }
      finally
      {
         notifier.notifyNodeEvicted(fqn, false, ctx);
      }
   }
}
