package org.jboss.cache.commands.legacy.write;

import org.jboss.cache.Fqn;
import org.jboss.cache.NodeSPI;
import org.jboss.cache.commands.legacy.ReversibleCommand;
import org.jboss.cache.commands.write.ClearDataCommand;
import org.jboss.cache.invocation.InvocationContext;
import org.jboss.cache.transaction.GlobalTransaction;

import java.util.HashMap;

/**
 * A version of {@link org.jboss.cache.commands.write.ClearDataCommand} which can be rolled back, for use with
 * pessimistic locking where changes are made directly on the data structures and may need to be reversed.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class PessClearDataCommand extends ClearDataCommand implements ReversibleCommand
{
   private HashMap originalData;

   public PessClearDataCommand(GlobalTransaction gtx, Fqn fqn)
   {
      super(gtx, fqn);
   }

   public PessClearDataCommand()
   {
   }

   @Override
   public Object perform(InvocationContext ctx)
   {
      if (globalTransaction != null)
      {
         NodeSPI n = ctx.lookUpNode(fqn);
         originalData = n == null ? null : new HashMap(n.getDataDirect());
      }
      return super.perform(ctx);
   }

   public void rollback()
   {
      if (trace) log.trace("rollback(" + globalTransaction + ", \"" + fqn + "\", " + originalData + ")");
      if (originalData != null && !originalData.isEmpty())
      {
         NodeSPI nodeSpi = dataContainer.peek(fqn, false, true);
         if (nodeSpi == null)
         {
            if (trace)
               log.trace("Not rolling back node clearance for node: " + fqn + " as it does not exist in the cache. " +
                     "This might be the result of an NoOp clear operation");
            return;
         }
         nodeSpi.putAllDirect(originalData);
      }
   }
}
