package org.jboss.cache.factories;

import org.jboss.cache.LegacyRegionManagerImpl;
import org.jboss.cache.RegionManager;
import org.jboss.cache.RegionManagerImpl;
import org.jboss.cache.factories.annotations.DefaultFactoryFor;

/**
 * Creates region managers
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 */
@DefaultFactoryFor(classes = RegionManager.class)
public class RegionManagerFactory extends ComponentFactory
{
   @SuppressWarnings("unchecked")
   protected <T> T construct(Class<T> componentType)
   {
      switch (configuration.getNodeLockingScheme())
      {
         case MVCC:
            return (T) new RegionManagerImpl();
         default:
            return (T) new LegacyRegionManagerImpl();
      }
   }
}