package org.jboss.cache.factories;

import org.jboss.cache.factories.annotations.DefaultFactoryFor;
import org.jboss.cache.statetransfer.DefaultStateTransferManager;
import org.jboss.cache.statetransfer.LegacyStateTransferManager;
import org.jboss.cache.statetransfer.StateTransferManager;

/**
 * Constructs {@link org.jboss.cache.statetransfer.StateTransferManager} instances.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 */
@DefaultFactoryFor(classes = StateTransferManager.class)
public class StateTransferManagerFactory extends ComponentFactory
{
   @SuppressWarnings("unchecked")
   protected <T> T construct(Class<T> componentType)
   {
      switch (configuration.getNodeLockingScheme())
      {
         case MVCC:
            return (T) new DefaultStateTransferManager();
         default:
            return (T) new LegacyStateTransferManager();
      }
   }
}
