package org.jboss.cache.factories.context;

import org.jboss.cache.invocation.InvocationContext;
import org.jboss.cache.invocation.MVCCInvocationContext;
import org.jboss.cache.transaction.MVCCTransactionContext;
import org.jboss.cache.transaction.TransactionContext;

import javax.transaction.RollbackException;
import javax.transaction.SystemException;
import javax.transaction.Transaction;

/**
 * Constructs contexts for MVCC locking
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 */
public class MVCCContextFactory implements ContextFactory
{
   public InvocationContext createInvocationContext()
   {
      return new MVCCInvocationContext();
   }

   public TransactionContext createTransactionContext(Transaction tx) throws SystemException, RollbackException
   {
      return new MVCCTransactionContext(tx);
   }
}
