package org.jboss.cache.interceptors;

import org.jboss.cache.DataContainer;
import org.jboss.cache.Fqn;
import org.jboss.cache.commands.write.EvictCommand;
import org.jboss.cache.factories.annotations.Inject;
import org.jboss.cache.invocation.InvocationContext;

import java.util.List;

/**
 * Passivation interceptor for optimistic and pessimistic locking
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class LegacyPassivationInterceptor extends PassivationInterceptor
{
   private DataContainer dataContainer;

   @Inject
   private void injectDataContainer(DataContainer dataContainer)
   {
      this.dataContainer = dataContainer;
   }

   @Override
   public Object visitEvictFqnCommand(InvocationContext ctx, EvictCommand command) throws Throwable
   {
      if (command.isRecursive())
      {
         for (Fqn f : getNodeList(command.getFqn())) passivate(ctx, f);
      }
      else
      {
         passivate(ctx, command.getFqn());
      }

      return invokeNextInterceptor(ctx, command);
   }

   private List<Fqn> getNodeList(Fqn startingPoint)
   {
      return dataContainer.getNodesForEviction(startingPoint, true);
   }
}
