package org.jboss.cache.invocation;

import org.jboss.cache.factories.annotations.Inject;
import org.jboss.cache.factories.annotations.NonVolatile;
import org.jboss.cache.factories.context.ContextFactory;

/**
 * Container and factory for thread locals
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 2.1.0
 */
@NonVolatile
public class InvocationContextContainer extends ThreadLocal<InvocationContext>
{
   ContextFactory contextFactory;

   @Inject
   public void injectContextFactory(ContextFactory contextFactory)
   {
      this.contextFactory = contextFactory;
   }

   @Override
   protected InvocationContext initialValue()
   {
      // create if this is initially unset
      return contextFactory.createInvocationContext();
   }
}
