package org.jboss.cache.invocation;

import org.jboss.cache.DataContainer;
import org.jboss.cache.Fqn;
import org.jboss.cache.NodeSPI;

import java.util.Map;

/**
 * This is to provide backward compatibility with legacy locking schemes.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class LegacyInvocationContext extends AbstractInvocationContext
{
   DataContainer container;

   public LegacyInvocationContext(DataContainer container)
   {
      this.container = container;
   }

   public NodeSPI lookUpNode(Fqn fqn)
   {
      return container.peek(fqn);
   }

   public void putLookedUpNode(Fqn f, NodeSPI n)
   {
      throw new UnsupportedOperationException("Should not be called on legacy locking schemes!");
   }

   public void clearLookedUpNodes()
   {
      // no-op
   }

   public Map<Fqn, NodeSPI> getLookedUpNodes()
   {
      throw new UnsupportedOperationException("Should not be called on legacy locking schemes!");
   }

   public InvocationContext copy()
   {
      LegacyInvocationContext copy = new LegacyInvocationContext(container);
      doCopy(copy);
      return copy;
   }
}
