package org.jboss.cache.passivation;

import static org.jboss.cache.factories.UnitTestCacheConfigurationFactory.buildSingleCacheLoaderConfig;
import org.testng.annotations.Test;

/**
 * tests passivation using file cache loader
 *
 * @author <a href="mailto:{hmesha@novell.com}">{Hany Mesha}</a>
 * @version $Id: PassivationToFileCacheLoaderTest.java 6093 2008-06-27 12:41:45Z manik.surtani@jboss.com $
 */
@Test(groups = "functional")
public class PassivationToFileCacheLoaderTest extends PassivationTestsBase
{
   protected void configureCache() throws Exception
   {

      String tmpLocation = null;
      String OS = System.getProperty("os.name").toLowerCase();
      if (OS.contains("win") || OS.contains("nt"))
      {
         tmpLocation = System.getProperty("java.io.tmpdir", "c:\\tmp");
      }
      else
      {
         tmpLocation = System.getProperty("jva.io.tmpdir", "/tmp");
      }

      cache.getConfiguration().setCacheLoaderConfig(buildSingleCacheLoaderConfig(true, null, "org.jboss.cache.loader.FileCacheLoader", "", false, false, false, false, false));
   }
}
